package util;



import model.Dobavljac;
import model.Proizvod;
import org.hibernate.*;
import org.hibernate.boot.Metadata;

import org.hibernate.boot.MetadataSources;
import org.hibernate.boot.registry.StandardServiceRegistry;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
import org.hibernate.cfg.Configuration;


public class HibernateUtility {
    private static StandardServiceRegistry registry;
   private static SessionFactory sessionFactory;

   public static SessionFactory getSessionFactory() {
      if (sessionFactory == null) {
         try {
            
            registry = new StandardServiceRegistryBuilder().configure("hibernate.cfg.xml").build();




            MetadataSources sources = new MetadataSources(registry);
                  //.addAnnotatedClass(Proizvod.class)
                  //.addAnnotatedClass(Dobavljac.class);

            Metadata metadata = sources.getMetadataBuilder().build();
            //Configuration configuration=new Configuration(sources);
            //sessionFactory=configuration.configure().buildSessionFactory();
            sessionFactory = metadata.getSessionFactoryBuilder().build();
            //new AnnotationConfiguration().configure("/hibernate.cfg.xml").buildSessionFactory();
             
             System.out.println(sessionFactory.getClassMetadata(Dobavljac.class));
         } catch (Exception e) {
            if (registry != null) {
               StandardServiceRegistryBuilder.destroy(registry);
            }
            e.printStackTrace();
         }
      }
      return sessionFactory;
   }

   public static void shutdown() {
      if (registry != null) {
         StandardServiceRegistryBuilder.destroy(registry);
      }
   }
}
